//
//  ViewController.m
//  CreateTransaction
//
//  Created by Suleiman, Qamar on 2016-07-11.
//  Copyright © 2016 Suleiman, Qamar. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController


- (IBAction)createTransactionAction:(id)sender
{
    NSString *payload = @"{\"status\": \"DRAFT\",\"roles\": [{\"id\": \"signer1\",\"signers\": [{\"email\": \"qamar.suleiman@esignlive.com\",\"firstName\": \"Qamar\",\"lastName\": \"Suleiman\"}]}],\"documents\": [{\"description\": \"this is description\",\"approvals\": [{\"role\": \"signer1\",\"fields\": [{\"type\":\"SIGNATURE\",\"subtype\": \"FULLNAME\",\"page\": 0,\"top\": 100,\"left\": 100,\"width\": 200,\"height\": 60}]}],\"name\": \"Document1\"}],\"name\": \"TransactionTest\"}";
    
    
    
    NSString *filePath = [[NSBundle mainBundle] pathForResource:@"testPDF" ofType:@"pdf"];
    NSData *fileData = [NSData dataWithContentsOfFile:filePath];
    
    
    NSString *serverAPIURL = @"https://sandbox.esignlive.com";
    NSURL *url = [NSURL URLWithString:[serverAPIURL stringByAppendingPathComponent:@"api/packages"]];
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
    
    
    /* 
     We Could Either use the Session token or the API Key
     */
    
    NSString *sessionToken = @"<session token here>";
    sessionToken = nil;
    if (sessionToken) {
        NSDictionary *cookieProperties = [NSDictionary dictionaryWithObjectsAndKeys:
                                          serverAPIURL, NSHTTPCookieDomain,
                                          @"\\", NSHTTPCookiePath,
                                          @"ESIGNLIVE_SESSION_ID", NSHTTPCookieName,
                                          sessionToken, NSHTTPCookieValue,
                                          nil];
        
        NSHTTPCookie *cookie = [NSHTTPCookie cookieWithProperties:cookieProperties];
        NSArray* cookieArray = [NSArray arrayWithObjects: cookie, nil];
        NSDictionary * headers = [NSHTTPCookie requestHeaderFieldsWithCookies:cookieArray];
        [request setAllHTTPHeaderFields:headers];
    }
    else
    {
        NSString *apiKEY = @"<API Key Here>";
        [request setValue:[NSString stringWithFormat:@"Basic %@",apiKEY] forHTTPHeaderField: @"Authorization"];
    }
    
    
    [request setHTTPMethod:@"POST"];
    
    //setup the body
    
    NSString *boundary = @"---------------------------14737809831466499882746641449";
    NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@",boundary];
    [request addValue:contentType forHTTPHeaderField: @"Content-Type"];
    
    NSMutableData *body = [NSMutableData data];
    [body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
    [body appendData:[[NSString stringWithFormat:@"Content-Disposition: form-data; name=\"payload\"\r\n\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
    [body appendData:[payload dataUsingEncoding:NSUTF8StringEncoding]];
    [body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
    
    [body appendData:[[NSString stringWithFormat:@"Content-Disposition: form-data; name=\"file\"; filename=\"%@\"\r\n",[filePath lastPathComponent]] dataUsingEncoding:NSUTF8StringEncoding]];
    
    [body appendData:[@"Content-Type: application/octet-stream\r\n\r\n" dataUsingEncoding:NSUTF8StringEncoding]];
    
    [body appendData:fileData];
    [body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
    
    [request setHTTPBody:body];
    
    
    [NSURLConnection sendAsynchronousRequest:request queue:[NSOperationQueue new] completionHandler:^(NSURLResponse * _Nullable response, NSData * _Nullable data, NSError * _Nullable connectionError) {
        
        
        NSDictionary *responseDict = [NSJSONSerialization JSONObjectWithData:data options:0 error:NULL];
        NSLog(@"%@",responseDict);
        
        
    }];

}

- (void)viewDidLoad {
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
